package demos;

/*
 * GraphDemo.java
 */

//package demos;

import acm.program.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;


public class GraphDemo extends GraphicsProgram {

	public void init() {
//		double x1 = 0.3333 * getWidth() - GRAPH_WIDTH / 2; 
//		double x2 = 0.6667 * getWidth() - GRAPH_WIDTH / 2;
//		double y = (getHeight() - GRAPH_HEIGHT) / 2;
//       (getWidth() doesn't work unless "init" is changed to "run")
//		System.out.println("getWidth(), getHeight(): " + getWidth() + ", " + getHeight() + ".");
		double x1 = 0.3333 * APPLICATION_WIDTH - GRAPH_WIDTH / 2;
		double x2 = 0.6667 * APPLICATION_WIDTH - GRAPH_WIDTH / 2;
		double y = (APPLICATION_HEIGHT - GRAPH_HEIGHT) / 2;
		model = new GraphModel();
		add(new BarGraphViewer(model, GRAPH_WIDTH, GRAPH_HEIGHT), x1, y);
		add(new PieGraphViewer(model, GRAPH_WIDTH, GRAPH_HEIGHT), x2, y);
		createController();
	}
	
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == graphButton || e.getSource() == dataField) {
			model.setData(convertStringToArray(dataField.getText()));
		}
	}
	
	private void createController() {
		dataField = new JTextField(35);
		graphButton = new JButton("Graph");
		dataField.addActionListener(this);
		graphButton.addActionListener(this);
		add(new JLabel("Data:"), SOUTH);
		add(dataField, SOUTH);
		add(graphButton, SOUTH);
	}
	
	private int[] convertStringToArray(String str) {
		StringTokenizer tokenizer = new StringTokenizer(str, " ,");
		ArrayList list = new ArrayList();
		while (tokenizer.hasMoreTokens()) {
			int value = Integer.parseInt(tokenizer.nextToken());
			list.add(new Integer(value));
		}
		int[] array = new int[list.size()];
		for (int i = 0; i < array.length; i++) {
			array[i] = ((Integer) list.get(i)).intValue();
		}
		return array;
	}
	
	public static final int APPLICATION_WIDTH = 800;
	public static final int APPLICATION_HEIGHT = 600;
	public static final int GRAPH_WIDTH = 120;
	public static final int GRAPH_HEIGHT = 120;
	
	private GraphModel model;
	private JTextField dataField;
	private JButton graphButton;
}
