package demos;

import java.util.*;

public class GraphModel {
	
	public GraphModel() {
		data = new int[0];
		viewers = new ArrayList();
	}
	
	public void addViewer(GraphViewer viewer) {
		viewers.add(viewer);
	}
	
	public void setData(int[] array) {
		data = new int[array.length];
		for (int i = 0; i < data.length; i++) {
			data[i] = array[i];
		}
		notifyViewers();
	}
	
	public int[] getData() {
		int[] array = new int[data.length];
		for (int i = 0; i < array.length; i++) {
			array[i] = data[i];
		}
		return array;
	}
	
	private void notifyViewers() {
		for (int i = 0; i < viewers.size(); i++) {
			GraphViewer viewer = (GraphViewer) viewers.get(i);
			viewer.update();
		}
	}
	
	private int[] data;
	private ArrayList viewers;

}
