package demos;

import acm.graphics.*;
import java.awt.*;


public abstract class GraphViewer extends GCompound {
	
	public GraphViewer(GraphModel model, double width, double height) {
		viewerModel = model;
		viewerWidth = width;
		viewerHeight = height;
		model.addViewer(this);
	}

	public abstract void createGraph(int[] data);
	
	public GRectangle getBounds() {
		return new GRectangle (getX(), getY(), viewerWidth, viewerHeight);
	}
	
	public void update() {
		removeAll();
		createGraph(viewerModel.getData());
	}
	
	public Color getColorForIndex(int k) {
		return COLORS[k % COLORS.length];
	}
	
	private static final Color[] COLORS = {
		Color.RED, Color.GREEN, Color.BLUE, Color.YELLOW, Color.PINK, Color.CYAN,
		Color.MAGENTA, Color.ORANGE
	};
	
	private GraphModel viewerModel;
	private double viewerWidth;
	private double viewerHeight;
}
