package demos;

import acm.graphics.*;

public class PieGraphViewer extends GraphViewer {
	
	public PieGraphViewer(GraphModel model, double width, double height) {
		super(model, width, height);
	}
	
	public void createGraph(int[] data) {
		int total = sumIntArray(data);
		double cx = getWidth() / 2;
		double cy = getHeight() / 2;
		double r = Math.min(cx, cy);
		double start = 90;
		for (int i = 0; i < data.length; i++) {
			double sweep = 360.0 * data[i] / total;
			GArc arc = new GArc(cx - r, cy - r, 2 * r, 2 * r, start, -sweep);
			arc.setFilled(true);
			arc.setFillColor(getColorForIndex(i));
			add(arc);
			start -= sweep;
		}
	}

	private int sumIntArray(int[] array) {
		int total = 0;
		for (int i = 0; i < array.length; i++) {
			total += array[i];
		}
		return total;
	}
}
